extern bool Manage_by_Trade_Comment = false;
extern string Trade_Comment = "test";
extern int TF = 15;
extern int Look_Back_Bars = 100;
extern int Distance_Peaks = 10;
extern int Min_SL = 15;
extern int Max_SL = 100;
extern int Add_To_Peak_for_Virtual_Real_SL = 8;
extern int Hard_Stop_for_Broker_Add_to_Vir = 10;
extern int Close_All_Pair_profit_dollars = 50;
extern bool Allow_Trailing_Stop = true;
extern int BreakEvenDistance = 25;
extern int BreakEvenPips = 10;
extern int DetectMove = 3;
extern int SLMove = 1;

int Slippage = 5;

int upper_peak_bar = -1;
double upper_peak_price = 0;
int lower_peak_bar = -1;
double lower_peak_price = 0;

double profit_buy;
double profit_sell;

int pip;
int nbuy, nsell;

int init(){
   if (Digits==3 || Digits==5) pip=10; else pip=1;
   //OrderSend(Symbol(),OP_BUY,0.1,Ask,1,0,0);
   return(0);
}
int deinit(){
   return(0);
}
int start(){
   CalcOrders();
   FindLastPeaks();
   DrawLines();
   CheckHardSL_calc_profit();
   CheckVirtualSL();
   if (Allow_Trailing_Stop) Trailing();

   return(0);
}

void CalcOrders(){
   nbuy = 0;
   nsell = 0;
   for (int i=OrdersTotal()-1; i>=0; i--){
      if (OrderSelect(i,SELECT_BY_POS)){
         if (OrderSymbol()==Symbol() && (OrderComment()==Trade_Comment || !Manage_by_Trade_Comment)){
            if (OrderType()==OP_BUY){
               nbuy++;
            }else if (OrderType()==OP_SELL){
               nsell++;
            }
         }
      }
   }
}

void FindLastPeaks(){
   upper_peak_bar=-1;
   lower_peak_bar=-1;
   int i,j;
   bool peak_upper = false;
   bool peak_lower = false;
   double last_sup, last_res;
   for (i=0; i<=Look_Back_Bars; i++){
      double sup = iCustom(Symbol(),TF,"Pipholic_SR",1,i);
      double res = iCustom(Symbol(),TF,"Pipholic_SR",0,i);
      if (i==0){
         last_sup = sup;
         last_res = res;
      }
      if (upper_peak_bar<0){
         upper_peak_bar = i;
         upper_peak_price = res;
      }else if (!peak_upper){
         if (res>upper_peak_price+(Distance_Peaks+Add_To_Peak_for_Virtual_Real_SL)*pip*Point){
            peak_upper = true;
         }else if (res>upper_peak_price){
            upper_peak_bar = i;
            upper_peak_price = res;
         }
      }
      if (lower_peak_bar<0){
         lower_peak_bar = i;
         lower_peak_price = sup;
      }else if (!peak_lower){
         if (sup<lower_peak_price-(Distance_Peaks+Add_To_Peak_for_Virtual_Real_SL)*pip*Point){
            peak_lower = true;
         }else if (sup<lower_peak_price){
            lower_peak_bar = i;
            lower_peak_price = sup;
         }
      }
      if (peak_upper && peak_lower) break;
   }

   
   if (upper_peak_bar<0){
      upper_peak_price = Bid+Max_SL*pip*Point;
   }else{
      ObjectCreate("peak_up",OBJ_ARROW,0,iTime(Symbol(),TF,upper_peak_bar),upper_peak_price);
      ObjectSet("peak_up",OBJPROP_PRICE1,upper_peak_price);
      ObjectSet("peak_up",OBJPROP_TIME1,iTime(Symbol(),TF,upper_peak_bar));
      upper_peak_price = upper_peak_price+Add_To_Peak_for_Virtual_Real_SL*pip*Point;
      if (upper_peak_price-Bid>Max_SL*pip*Point) upper_peak_price = Bid+Max_SL*pip*Point;
   }
   if (lower_peak_bar<0){
      lower_peak_price = Bid-Max_SL*pip*Point;
   }else{
      ObjectCreate("peak_low",OBJ_ARROW,0,iTime(Symbol(),TF,lower_peak_bar),lower_peak_price);
      ObjectSet("peak_low",OBJPROP_PRICE1,lower_peak_price);
      ObjectSet("peak_low",OBJPROP_TIME1,iTime(Symbol(),TF,lower_peak_bar));
      lower_peak_price = lower_peak_price-Add_To_Peak_for_Virtual_Real_SL*pip*Point;
      if (Bid-lower_peak_price>Max_SL*pip*Point) lower_peak_price = Bid-Max_SL*pip*Point;
   }

   
   if (upper_peak_price-last_res<Min_SL*pip*Point) upper_peak_price = last_res+Min_SL*pip*Point;
   if (upper_peak_price-last_res>Max_SL*pip*Point) upper_peak_price = last_res+Max_SL*pip*Point;
   
   if (last_sup-lower_peak_price<Min_SL*pip*Point) lower_peak_price = last_sup-Min_SL*pip*Point;
   if (last_sup-lower_peak_price>Max_SL*pip*Point) lower_peak_price = last_sup-Max_SL*pip*Point;
   

   //Print(lower_peak_bar," ",upper_peak_bar," ",lower_peak_price," ",upper_peak_price);
}

void DrawLines(){
   //upper_peak_price = upper_peak_price+Add_To_Peak_for_Virtual_Real_SL*pip*Point;
   //lower_peak_price = lower_peak_price-Add_To_Peak_for_Virtual_Real_SL*pip*Point;
   
   if (ObjectFind("upper_virtual_sl")<0){
      if (nsell>0){
         ObjectCreate("upper_virtual_sl",OBJ_HLINE,0,0,upper_peak_price);
         ObjectSet("upper_virtual_sl",OBJPROP_COLOR,Yellow);
      }
   }else{
      if (nsell>0){
         ObjectSet("upper_virtual_sl",OBJPROP_PRICE1,upper_peak_price);
      }else{
         ObjectDelete("upper_virtual_sl");
      }
   }

   if (ObjectFind("lower_virtual_sl")<0){
      if (nbuy>0){
         ObjectCreate("lower_virtual_sl",OBJ_HLINE,0,0,lower_peak_price);
         ObjectSet("lower_virtual_sl",OBJPROP_COLOR,Yellow);
      }
   }else{
      if (nbuy>0){
         ObjectSet("lower_virtual_sl",OBJPROP_PRICE1,lower_peak_price);
      }else{
         ObjectDelete("lower_virtual_sl");
      }
   }


   if (ObjectFind("upper_hard_sl")<0){
      if (nsell>0){
         ObjectCreate("upper_hard_sl",OBJ_HLINE,0,0,upper_peak_price+Hard_Stop_for_Broker_Add_to_Vir*pip*Point);
         ObjectSet("upper_hard_sl",OBJPROP_COLOR,Red);
      }
   }else{
      if (nsell>0){
         ObjectSet("upper_hard_sl",OBJPROP_PRICE1,upper_peak_price+Hard_Stop_for_Broker_Add_to_Vir*pip*Point);
      }else{
         ObjectDelete("upper_hard_sl");
      }
   }

   if (ObjectFind("lower_hard_sl")<0){
      if (nbuy>0){
         ObjectCreate("lower_hard_sl",OBJ_HLINE,0,0,lower_peak_price-Hard_Stop_for_Broker_Add_to_Vir*pip*Point);
         ObjectSet("lower_hard_sl",OBJPROP_COLOR,Red);
      }
   }else{
      if (nbuy>0){
         ObjectSet("lower_hard_sl",OBJPROP_PRICE1,lower_peak_price-Hard_Stop_for_Broker_Add_to_Vir*pip*Point);
      }else{
         ObjectDelete("lower_hard_sl");
      }
   }

}

void CheckHardSL_calc_profit(){
   profit_buy = 0;
   profit_sell = 0;
   double sl_buy = ObjectGet("lower_hard_sl",OBJPROP_PRICE1);
   double sl_sell = ObjectGet("upper_hard_sl",OBJPROP_PRICE1);
   for (int i=OrdersTotal()-1; i>=0; i--){
      if (OrderSelect(i,SELECT_BY_POS)){
         if (OrderSymbol()==Symbol() && (OrderComment()==Trade_Comment || !Manage_by_Trade_Comment)){
            if (OrderType()==OP_BUY){
               profit_buy+=OrderProfit()+OrderCommission()+OrderSwap();
               if (sl_buy>Point && OrderStopLoss()!=NormalizeDouble(sl_buy,Digits) && OrderStopLoss()<OrderOpenPrice()){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(sl_buy,Digits),OrderTakeProfit(),OrderExpiration());
               }
            }else if (OrderType()==OP_SELL){
               profit_sell+=OrderProfit()+OrderCommission()+OrderSwap();
               if (sl_sell>Point && OrderStopLoss()!=NormalizeDouble(sl_sell,Digits) && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()<Point)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(sl_sell,Digits),OrderTakeProfit(),OrderExpiration());
               }
            }
         }
      }
   }
}

void CheckVirtualSL(){
   double sl_buy = ObjectGet("lower_virtual_sl",OBJPROP_PRICE1);
   double sl_sell = ObjectGet("upper_virtual_sl",OBJPROP_PRICE1);
   for (int i=OrdersTotal()-1; i>=0; i--){
      if (OrderSelect(i,SELECT_BY_POS)){
         if (OrderSymbol()==Symbol() && (OrderComment()==Trade_Comment || !Manage_by_Trade_Comment)){
            if (OrderType()==OP_BUY){
               if (Bid<=sl_buy || profit_buy>=Close_All_Pair_profit_dollars){
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage*pip);
               }
            }else if (OrderType()==OP_SELL){
               if ((sl_sell>Point && Bid>=sl_sell) || profit_sell>=Close_All_Pair_profit_dollars){
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage*pip);
               }
            }
         }
      }
   }
}

void Trailing(){
   int i;
   for (i=OrdersTotal()-1; i>=0; i--){
      if (OrderSelect(i,SELECT_BY_POS)){
         if (OrderSymbol()==Symbol() && (OrderComment()==Trade_Comment || !Manage_by_Trade_Comment)){
            if (OrderType()==OP_BUY){
               if (BreakEvenDistance>0 && Bid>OrderOpenPrice()+BreakEvenDistance*pip*Point && NormalizeDouble(OrderStopLoss(),Digits)!=NormalizeDouble(OrderOpenPrice()+BreakEvenPips*pip*Point,Digits)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+BreakEvenPips*pip*Point,Digits),OrderTakeProfit(),OrderExpiration());
                  continue;
               }
               if (NormalizeDouble(OrderStopLoss(),Digits)==NormalizeDouble(OrderOpenPrice()+BreakEvenPips*pip*Point,Digits)){
                  if (ObjectFind("sl_"+OrderTicket())<0){
                     ObjectCreate("sl_"+OrderTicket(),OBJ_HLINE,0,0,OrderStopLoss());
                     ObjectSet("sl_"+OrderTicket(),OBJPROP_COLOR,Blue);
                     ObjectSetText("sl_"+OrderTicket(),DoubleToStr(Bid,Digits),10);
                  }
                  double sl_buy = ObjectGet("sl_"+OrderTicket(),OBJPROP_PRICE1);
                  double new_sl_buy = sl_buy;
                  if (MathAbs(Bid-StrToDouble(ObjectDescription("sl_"+OrderTicket())))>=DetectMove*pip*Point){
                     new_sl_buy = sl_buy + SLMove*pip*Point;
                     ObjectSet("sl_"+OrderTicket(),OBJPROP_PRICE1,NormalizeDouble(new_sl_buy,Digits));
                     ObjectSetText("sl_"+OrderTicket(),DoubleToStr(Bid,Digits),10);
                  }
               }
            }else if (OrderType()==OP_SELL){
               if (BreakEvenDistance>0 && Ask<OrderOpenPrice()-BreakEvenDistance*pip*Point && NormalizeDouble(OrderStopLoss(),Digits)!=NormalizeDouble(OrderOpenPrice()-BreakEvenPips*pip*Point,Digits)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-BreakEvenPips*pip*Point,Digits),OrderTakeProfit(),OrderExpiration());
                  continue;
               }
               if (NormalizeDouble(OrderStopLoss(),Digits)==NormalizeDouble(OrderOpenPrice()-BreakEvenPips*pip*Point,Digits)){
                  if (ObjectFind("sl_"+OrderTicket())<0){
                     ObjectCreate("sl_"+OrderTicket(),OBJ_HLINE,0,0,OrderStopLoss());
                     ObjectSet("sl_"+OrderTicket(),OBJPROP_COLOR,Blue);
                     ObjectSetText("sl_"+OrderTicket(),DoubleToStr(Bid,Digits),10);
                  }
                  double sl_sell = ObjectGet("sl_"+OrderTicket(),OBJPROP_PRICE1);
                  double new_sl_sell = sl_sell;
                  if (MathAbs(Bid-StrToDouble(ObjectDescription("sl_"+OrderTicket())))>=DetectMove*pip*Point){
                     new_sl_sell = sl_sell - SLMove*pip*Point;
                     ObjectSet("sl_"+OrderTicket(),OBJPROP_PRICE1,NormalizeDouble(new_sl_sell,Digits));
                     ObjectSetText("sl_"+OrderTicket(),DoubleToStr(Bid,Digits),10);
                  }
               }
            }
         }
      }
   }

   for (i=OrdersHistoryTotal()-1; i>=MathMax(OrdersHistoryTotal()-100,0); i--){
      if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if (ObjectFind("sl_"+OrderTicket())>=0) ObjectDelete("sl_"+OrderTicket());
      }
   }

   for (i=OrdersTotal()-1; i>=0; i--){
      if (OrderSelect(i,SELECT_BY_POS)){
         if (OrderSymbol()==Symbol() && (OrderComment()==Trade_Comment || !Manage_by_Trade_Comment)){
            if (OrderType()==OP_BUY){
               if (ObjectFind("sl_"+OrderTicket())>=0){
                  sl_buy = ObjectGet("sl_"+OrderTicket(),OBJPROP_PRICE1);
                  if (Bid<=sl_buy){
                     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage*pip);
                     return(0);
                  }
               }
            }else if (OrderType()==OP_SELL){
               if (ObjectFind("sl_"+OrderTicket())>=0){
                  sl_sell = ObjectGet("sl_"+OrderTicket(),OBJPROP_PRICE1);
                  if (Ask>=sl_sell){
                     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage*pip);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

